import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.nio.file.Paths;
import org.apache.lucene.analysis.Analyzer;
//import org.apache.lucene.analysis.cn.smart.SmartChineseAnalyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
//import org.apache.lucene.document.IntField;
import org.apache.lucene.document.StringField;
import org.apache.lucene.document.TextField;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.*;


public class BuildIndex {
	private IndexWriter writer;
	
	public IndexWriter getIndexWriter(String indexDir) throws IOException {
        Directory dir= FSDirectory.open(Paths.get(indexDir));
        Analyzer analyzer=new StandardAnalyzer();
        IndexWriterConfig conf=new IndexWriterConfig(analyzer);
        IndexWriter writer= new IndexWriter(dir, conf);
        return writer;
    }
	
	 public void index(String indexDir, String dataDir) throws IOException, ParseException {
	        this.writer=getIndexWriter(indexDir);
	        
	        File folder = new File(dataDir);
	        File[] listOfFiles = folder.listFiles();
	        System.out.println(listOfFiles);
	        for (File file : listOfFiles) {
	            if (file.isFile()) {
	            	 // parsing file ".json"
	    	        Object ob = new JSONParser().parse(new FileReader(dataDir+file.getName()));
	    	        JSONObject js = (JSONObject) ob;
	    	        String s1 = (String) js.get("SENTENCE_1");
	    	        String s2 = (String) js.get("SENTENCE_2");
	    	        int id  = (int) (long) js.get("ID");
	    	        System.out.println("id is: " + id);
	    	        System.out.println("First sentence is: " + s1);
	    	        System.out.println("Last sentence is: " + s2);
	                //System.out.println(file.getName());
	    	        addDoc(Integer.toString(id), s1, s2);
	    	       
	            }
	        }
	        System.out.println("all file has been indexed");
	        writer.close();
	         
	         
	    }
	    
	    private void addDoc(String id, String s1,String s2) throws IOException {
	        Document doc = new Document();
	        
	        doc.add(new TextField("id",id, Field.Store.YES));
	        doc.add(new TextField("s1", s1, Field.Store.YES));
	        doc.add(new TextField("s2", s2, Field.Store.YES));
	        
	    
	        writer.addDocument(doc);
	      }
	    
	    public static void main(String[] args) throws ParseException {
	        try {
	            new BuildIndex().index("you index path",
	            		"your data path");
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }
	
}
